/* This program is designed to make pleasing lighting effects using the 
   12 colours of a low cost ir controlled light puck.
   I snipped out the serial comms code and it includes error_message 
   that I can't find reference to and it fails linking.
 */

#include <stdio.h>
#include <errno.h>
#include <fcntl.h> 
#include <string.h>
#include <termios.h>
#include <unistd.h>
#include <stdlib.h>
#include <math.h>

char code01[]="Y00000001111111101000000001111111Z"; //timer duration 1 
char code02[]="Y00000001111111100100000010111111Z"; //timer duration 2
char code03[]="Y00000001111111101100000000111111Z"; //random color cycles
char code04[]="Y00000001111111100010000011011111Z"; //full red
char code05[]="Y00000001111111101010000001011111Z"; //full green
char code06[]="Y00000001111111100110000010011111Z"; //full blue
char code07[]="Y00000001111111101110000000011111Z"; //white-pink
char code08[]="Y00000001111111100001000011101111Z"; //white-lime
char code09[]="Y00000001111111101001000001101111Z"; //lightblue
char code10[]="Y00000001111111100101000010101111Z"; //white-yellow
char code11[]="Y00000001111111100011000011001111Z"; //white-blue
char code12[]="Y00000001111111101011000001001111Z"; //mid blue
char code13[]="Y00000001111111100111000010001111Z"; //mid violet
char code14[]="Y00000001111111100100100010110111Z"; //turn on
char code15[]="Y00000001111111100101100010100111Z"; //turn off
char code16[]="Y00000001111111101101100000100111Z"; //turquoise
char code17[]="Y00000001111111100111100010000111Z"; //toggle full white brightness
char code18[]="Y00000001111111101111100000000111Z"; //pink

int
set_interface_attribs (int fd, int speed, int parity)
{
        struct termios tty;
        if (tcgetattr (fd, &tty) != 0)
        {
//              error_message ("error %d from tcgetattr", errno);
                fprintf(stderr, "error %d from tcgetattr", errno);
                return -1;
        }

        cfsetospeed (&tty, speed);
        cfsetispeed (&tty, speed);

        tty.c_cflag = (tty.c_cflag & ~CSIZE) | CS8;     // 8-bit chars
        // disable IGNBRK for mismatched speed tests; otherwise receive break
        // as \000 chars
        tty.c_iflag &= ~IGNBRK;         // disable break processing
        tty.c_lflag = 0;                // no signaling chars, no echo,
                                        // no canonical processing
        tty.c_oflag = 0;                // no remapping, no delays
        tty.c_cc[VMIN]  = 0;            // read doesn't block
        tty.c_cc[VTIME] = 5;            // 0.5 seconds read timeout

// Set up for hardware flow control
        tty.c_iflag &= ~(IXON | IXOFF | IXANY); // shut off xon/xoff ctrl
        tty.c_cflag |= CRTSCTS;

        tty.c_cflag |= (CLOCAL | CREAD);// ignore modem controls,
                                        // enable reading
        tty.c_cflag &= ~(PARENB | PARODD);      // shut off parity
        tty.c_cflag |= parity;
        tty.c_cflag &= ~CSTOPB;
 
        if (tcsetattr (fd, TCSANOW, &tty) != 0)
        {
//              error_message ("error %d from tcsetattr", errno);
                fprintf(stderr, "error %d from tcgetattr", errno);
                return -1;
        }
        return 0;
}

void
set_blocking (int fd, int should_block)
{
        struct termios tty;
        memset (&tty, 0, sizeof tty);
        if (tcgetattr (fd, &tty) != 0)
        {
//              error_message ("error %d from tggetattr", errno);
                fprintf(stderr, "error %d from tcgetattr", errno);
                return;
        }

        tty.c_cc[VMIN]  = should_block ? 1 : 0;
        tty.c_cc[VTIME] = 5;            // 0.5 seconds read timeout

        if (tcsetattr (fd, TCSANOW, &tty) != 0)
//              error_message ("error %d setting term attributes", errno);
                fprintf(stderr, "error %d from tcgetattr", errno);
}

int 
random_number(int lower, int upper) 
{ 
	int num = (rand() % (upper - lower + 1)) + lower; 
	printf ("random # - %d in range %d-%d\n",num,lower,upper);        
	return(num);
} 

void 
write_ir_packet (char *ir_code, int filehandle)
{ 
	int loopcounter;
        for (loopcounter=1;loopcounter<=strlen(ir_code);loopcounter++)
        while (write(filehandle, &ir_code[loopcounter-1], 1) == -1) { }
        printf ("sending - %s\n", ir_code);
}

void 
color_blink (char *ir_code_in1, char *ir_code_in2,int blink_delay, int filehandle, int times)
{
	int loopcounter;
        for (loopcounter=0; loopcounter<=times; loopcounter++)
        {
         write_ir_packet (ir_code_in1,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (ir_code_in2,filehandle);
         usleep (1000*blink_delay);
        }  
}       

void
color_cycle (int blink_delay, int filehandle, int times)
{
	int loopcounter;
        for (loopcounter=0; loopcounter<=times; loopcounter++)
        {      
         write_ir_packet (code04,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code13,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code10,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code05,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code18,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code08,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code12,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code16,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code06,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code07,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code11,filehandle);
         usleep (1000*blink_delay);
         write_ir_packet (code09,filehandle);
         usleep (1000*blink_delay);
        }
}

void
random_primaries (int blink_delay, int filehandle, int times)
{
        int random_selector;
	int loopcounter;
        for (loopcounter=0; loopcounter<=times; loopcounter++)
        {      
         random_selector=random_number(1,29);
         if (random_selector<10) { write_ir_packet (code04,filehandle); }
         if ((random_selector<20)&&(random_selector>9)) { write_ir_packet (code05,filehandle); }
         if ((random_selector<30)&&(random_selector>19)) { write_ir_packet (code06,filehandle); }
         usleep (1000*blink_delay);
        }
}

void
random_tints (int blink_delay, int filehandle, int times)
{
        int random_selector;
	int loopcounter;
        for (loopcounter=0; loopcounter<=times; loopcounter++)
        {      
         random_selector=random_number(1,39);
         if (random_selector<10) { write_ir_packet (code07,filehandle); }
         if ((random_selector<20)&&(random_selector>9)) { write_ir_packet (code08,filehandle); }
         if ((random_selector<30)&&(random_selector>19)) { write_ir_packet (code10,filehandle); }
         if ((random_selector<40)&&(random_selector>29)) { write_ir_packet (code11,filehandle); }
         usleep (1000*blink_delay);
        }
}

void
color_morph (char *ir_code_in1, char *ir_code_in2, int filehandle, int times)
{
        float amount_1;
        float amount_2;
        float slicesize=180/times; 
	int loopcounter;
         
        for (loopcounter=10; loopcounter<=(times-10); loopcounter++)
        {
         amount_2=slicesize*loopcounter;
         amount_1=180-amount_2;
         if (amount_1>30) write_ir_packet (ir_code_in1,filehandle);
         usleep (1000*amount_1);
         if (amount_2>30) write_ir_packet (ir_code_in2,filehandle);
         usleep (1000*amount_2);
        }  
}      

void
color_hold (char *ir_code_in1, int filehandle, long delay)
{
	 int loopcounter;
         int divisor=trunc(delay/1000);
         int remainder=delay-(divisor*1000);
         for (loopcounter=0; loopcounter<divisor; loopcounter++) 
         {
          sleep(1);
         }
         write_ir_packet (ir_code_in1,filehandle);
         usleep (1000*remainder);
}        

int
main ()
{
// My arduino is on ttyUSB0, you may have to alter the next line
        char *portname = "/dev/ttyUSB0";

        int loopcounter;
        int fd = open (portname, O_RDWR | O_NOCTTY | O_SYNC);
        if (fd < 0)
        {
//       error_message ("error %d opening %s: %s", errno, portname, strerror (errno));
         fprintf(stderr, "error %d opening %s: %s", errno, portname, strerror (errno));
         return(0);
        }

set_interface_attribs (fd, B115200, 0);  // set speed to 115,200 bps, 8n1 (no parity)
set_blocking (fd, 0);                    // set no blocking
/* When the port opens the arduino puts out a pulse on the user led line,
   so you have to wait 2 seconds to allow the puck to reset */
        sleep (2);
//turn light on
        write_ir_packet(code14,fd);
        usleep(500000);
/* put your light routines here
   times are all in milliseconds max is 1000ms
   except for color_hold which allows up to 1000000ms */
	color_cycle(400,fd,2);
        random_primaries (400,fd,20);
        random_tints (400,fd,20);
        color_blink(code04,code06,300,fd,30);
        color_morph(code09,code06,fd,50);
        color_morph(code06,code18,fd,50);
        color_morph(code18,code04,fd,50);
        color_hold(code04,fd,2500);
//turn light off
        write_ir_packet(code15,fd);
        return(1);
}
