/* This source transmits in IR, a provided through USB serial, set of 
   32 bits compliant to the NEC IR protocol.
   
   The USB serial format is
   'Y' - Start data 
   Followed by 32 bits comprising the 4 bytes of the protocol.
   '0' or '1' - Data
   'Z' - End data
   */

bool nec_bits[32];
int serial_input_byte;
int array_position=0;
int loopcounter;
bool loadstate=false;
  
void setup() {
     Serial.begin(115200);
     pinMode(LED_BUILTIN, OUTPUT);
}

void transmit_modulate_block () {
 // 26.3us with 1:4 duty cycle
 // These changes had to be made for instruction time and level rise 
     digitalWrite(LED_BUILTIN, HIGH);
     delayMicroseconds(14); 
     digitalWrite(LED_BUILTIN, LOW);
     delayMicroseconds(8);
}

void transmit_data() {
//The header - 343 modulated blocks - 9ms
     for (loopcounter=0;loopcounter<=343;loopcounter++) {
      transmit_modulate_block(); 
     }
//Perform standard low period 4.5ms
     delayMicroseconds(4500);
//Transmit bits
     for (array_position=0;array_position<=31;array_position++)
     {
      for (loopcounter=0;loopcounter<=22;loopcounter++) {
      transmit_modulate_block(); 
      }     
      if (nec_bits[array_position]==true) {
//     delayMicroseconds(1690); 
// Fix execution time 
       delayMicroseconds(1670);   
      }
      else {
//     delayMicroseconds(565);
// Fix execution time
       delayMicroseconds(545);
      } 
     }
//Perform Final Pulse
     for (loopcounter=0;loopcounter<=22;loopcounter++) {
      transmit_modulate_block();
     } 
}

void loop() {
    
     while (Serial.available() == 0) {}
     serial_input_byte = Serial.read();
//   Serial.write(serial_input_byte);  if you want to see what you typed
     if (array_position==33) { loadstate=false; }
 
     switch (serial_input_byte)
     {
      case 'Y':
       loadstate=true;
       array_position=0;
       break;
  
      case 'Z':
       if (loadstate==true) 
       {
        if (array_position==32) { transmit_data(); }
        loadstate=false;
       }
       break;

      case '0':
       if (loadstate==true)
       {
        nec_bits[array_position]=false;
        array_position++;        
       } 
       break;

      case '1':
       if (loadstate==true)
       {
        nec_bits[array_position]=true;
        array_position++;         
       } 
       break;

       default: {}
   
     } 
 }
